Import jnk

Global MySeed=378
Global Debug=0

Global GameName$="Chicky Crosses the Road"
Global CompleteStall
Global chk[1024]
Global car[1024]
Global home[4]

Global gw,gh,chks,ang,cars,Level,abang

Global cary,carx,chky,chkx,likely

Class MainLoop Extends App	

	Method OnCreate ()
		LoaderPause=240
		SetFont Null
		SetResolution(640,480)
		SetCLSCol(10,10,10)
		SetUpdateRate 60
		GameMode=0
		Loader=1
		FadeIn=0	FadeOut=1	Drop=0
		LoadGame
		MenuIn=-(256*(Ceil(jscrw/256)+1))
		If (jscrh>jscrw) Then MenuIn=-(256*(Ceil(jscrh/256)+1))
		GameHasPlayed=0
	End
	
	Method OnUpdate()
		Device()
		If (Loader>0) Then Do_Loader
		If (Loader<1)
			If (GameMode<>0) Then MenuIn=-(256*(Ceil(jscrw/256)+1))
			If (GameMode<>0 And jscrh>jscrw) Then MenuIn=-(256*(Ceil(jscrh/256)+1))

			If (GameMode=0) Then Do_Menu			
			If (GameMode=1) Then GameHasPlayed=1	Do_Gameplay
			If (GameMode=2) Then Scores() SaveGame()	GameMode=0
		End

		GameSpeed=1000/(Millisecs()-LastFrameb)
		LastFrameb=Millisecs()
	End
	
	Method OnRender()
		Device()
		If (Loader>0) Then Draw_Loader
		If (Loader<1)		
			If (GameMode=0) Then Draw_Menu
			If (GameMode=1) Then Draw_Gameplay
		End
		
		If (Debug=1)
			ResetDraw
			UseFont 1
			Text 1,1,1000/(Millisecs()-LastFrame)
			Text jscrw-1,1, GameSpeed,2
			LastFrame=Millisecs()
		End
	End
	
End


Function Do_Loader()
	Select Loader
		Case 1
			img[1023]=LoadImage("BG_Grid.png",1,Image.MidHandle)
			sfx[1023]=LoadSound("open.mp3")
		Case 2
			img[1022]=LoadImage("logo.png",1,Image.MidHandle)
			sfx[1]=LoadSound("ch01.mp3")
		Case 3
			img[1021]=LoadImage("button.png",1,Image.MidHandle)
			sfx[2]=LoadSound("ch02.mp3")
		Case 4
			img[1020]=LoadImage("BG_Texture.png",1,Image.MidHandle)
			sfx[3]=LoadSound("ch03.mp3")
		Case 5
			img[1019]=LoadImage("monkey.png",1,Image.MidHandle)
			sfx[4]=LoadSound("ch04.mp3")			
		Case 6
			LoadFont(1,"SVBasicManual_(17x29).png")
			UseFont 1
		Case 7
			LoadFont(2,"SVBasicManual_(11x18).png")
		Case 8
			img[1]=LoadImage("road.png",1,Image.MidHandle)
			sfx[5]=LoadSound("ch05.mp3")
		Case 9
			img[2]=LoadImage("chick.png",64,64,16,Image.MidHandle)
			sfx[6]=LoadSound("ch06.mp3")
		Case 10
			img[3]=LoadImage("nest.png",1,Image.MidHandle)
			sfx[7]=LoadSound("hit.mp3")			
		Case 11
			img[4]=LoadImage("grass.png",1,Image.MidHandle)
		Case 12
			img[5]=LoadImage("arrow.png",1,Image.MidHandle)

		Case 13
			img[6]=LoadImage("truckl.png",1,Image.MidHandle)
		Case 14
			img[7]=LoadImage("truckr.png",1,Image.MidHandle)

		Default
			If LoaderPause<=0 Then Loader=-1
	End Select



	Loader=Loader+1
	LoaderPause=LoaderPause-1
	If Loader=10 Then PlaySound sfx[1023]
	If Loader>5
		FadeIn=FadeIn+0.015
		If FadeIn>1
			FadeIn=1
			FadeOut=FadeOut-.008
			If FadeOut<0 Then FadeOut=0
		End
		If Loader>160 Then Drop=Drop+jscrh/60
	End
End

Function Draw_Loader()
	CLS3D
	ResetDraw
	SetCol J_CLS_Red*FadeIn,J_CLS_Green*FadeIn,J_CLS_Blue*FadeIn,1
	Rect 0,0,jscrw+8,jscrh+8
	ResetDraw
	If Loader>5
		Alpha FadeOut
		For x=0 To (jscrw/256)+1
		For y=0 To (jscrh/256)+1
			DrawImg img[1020],(x*256),y*256
		Next
		Next
		SetSize .6
		DrawImg img[1019],jscrw/2,jscrh*.3,0,1,1
	End
	ResetDraw	
	
	If Loader>5
		Alpha FadeIn*1
		DrawImg img[1022],jscrw/2,jscrh*.7+(Drop),0,1,1
	Endif
End


Function Do_Menu()
	If MenuIn<0 Then MenuIn=MenuIn+16
	If MenuIn>0 Then MenuIn=0
End

Function Draw_Menu()
	
	' Background Grid
	If MenuIn<0 And GameHasPlayed=1
		CLS3D
		Draw_Gameplay

	End
	
	If MenuIn=0 Or GameHasPlayed=0 Then CLS3D	EndofGame=0
	
		ResetDraw
		SetCol J_CLS_Red,J_CLS_Green,J_CLS_Blue,1
		Rect MenuIn-4,-4,jscrw+8,jscrh+8
		ResetDraw

	Alpha .15
	For x=0 To (jscrw/256)+1
	For y=0 To (jscrh/256)+1
		DrawImg img[1023],(x*256-(menux Mod 256))+MenuIn,y*256
	Next
	Next
	
		
	' Colour Overlay
	SeedRnd MySeed
	Repeat
		menuR=Floor(Rnd(2))*100
		menuG=Floor(Rnd(2))*100
		menuB=Floor(Rnd(2))*100
	Until menuR+menuG+menuB>100
	
	SetCol menuR*.7,menuG*.7,menuB*.7,.6
	Rect 0+MenuIn,0,jscrw,jscrh
	SetCol menuG*.5,menuB*.5,menuR*.5,.6
	Rect 0-MenuIn,32,jscrw,32
	SetCol menuR*.9,menuG*.9,menuB*.9,.6
	Rect jscrw-140,0-MenuIn,136,jscrh


	' Text
	UseFont 1
	ResetDraw
	Text 8-MenuIn,46,"Game Name",0,1

	UseFont 2
	Text jscrw-(136/2),96-MenuIn,"Top 10",1
	For i=0 To 9
		ttxt=(i+1)
		If i<9 Then ttxt=" "+(i+1)
		Text jscrw-132,(128+i*20)-MenuIn,ttxt+". "+(("00000000"+Highscore[i+(GameType*10)])[-7..])
	Next
	
	' Logo
	ResetDraw
	SetSize .25
	DrawImg img[1022],jscrw-74,48+MenuIn,0,1,1

	SetSize 1
	' Buttons
	If Mousein(jscrw-128,MenuIn,128,96) And md=1
		mudown=1
		SetCol 0,0,0,.75
		Rect 32,32,jscrw-64,jscrh-64
	End
	
	x=((jscrw-150)/2)+MenuIn
	y=80
	a=(jscrh-80)
	a=a/3
	
	UseFont 2
	y=y+a/2
	If Button(0,"Easy",x,y) Then StartGame()
	y=y+a
	If Button(1,"Normal",x,y) Then StartGame()
	y=y+a
	If Button(2,"Hard",x,y)	Then StartGame()
	y=y+a
		
	If md=0 Then mudown=0
End


Function StartGame()
	EndofGame=0
	Score=0
	Dead=0
	Level=0
	mudown=1
	GameMode=1
	Make_Level(GameType+2)
End


Function Make_Level(chicks)
Level=Level+1
CompleteStall=0
	gw=jscrw/32
	gh=jscrh/32
	If chicks>4 Then chicks=4
	chicks=1
	For n=0 To 1023
		car[n]=0
		chk[n]=0
	Next
	
	For n=1 To chicks
		chk[n*10]=Rand(2,gw-3)
		chk[n*10+1]=gh-1
		chk[n*10+2]=0
		chk[n*10+3]=Rand(0,63)
		
		chk[n*10+9]=0
	Next
	chks=chicks
	
	
	cars=(Level*(GameType+2))+(2*(GameType+2))
	If cars>25 Then cars=25
	For n=1 To cars
		car[n*10+9]=1
		car[n*10+0]=Rand(-2,gw+2)*32
		Repeat
			likely=16
			y=Rand(2,gh-2)*32
			For a=1 To n-1
				If car[a*10+1]=y Then likely=likely-Rand(2,5)
			Next
		Until likely>10
		car[n*10+1]=y
			
		car[n*10+4]=Rand(1,4)
	Next
	For n=0 To 3
		home[n]=0
	Next
End

Function Do_Gameplay()
	If EndofGame<>0
		EndofGameStall=EndofGameStall+1
		If EndofGameStall=30 Then GameMode=2 EndofGameStall=0
	End
	
	If md=0 Then mudown=0

	If EndofGame=0
	For n=1 To chks
		If chk[n*10+9]=0
			If chk[n*10+4]<0 Then chk[n*10+4]=chk[n*10+4]+2
			If chk[n*10+4]>0 Then chk[n*10+4]=chk[n*10+4]-2
			If chk[n*10+5]<0 Then chk[n*10+5]=chk[n*10+5]+2
			If chk[n*10+5]>0 Then chk[n*10+5]=chk[n*10+5]-2
		End
	Next

If abang>0 Then abang=abang-1

	For n=1 To cars

		
		If ((car[n*10+1]/32) Mod 2)=0
			car[n*10]=car[n*10]-car[n*10+4]
			If car[n*10]<-64
				car[n*10]=car[n*10]+jscrw+128
				car[n*10+4]=Rand(1,4)
			End
		End
		If ((car[n*10+1]/32) Mod 2)=1
			car[n*10]=car[n*10]+car[n*10+4]
			If car[n*10]>jscrw+64
				car[n*10]=car[n*10]-(jscrw+128)
				car[n*10+4]=Rand(1,4)
			End
		End
		
		For a=1 To cars
			If a<>n And car[n*10+1]=car[a*10+1]
				If ((car[n*10+1]/32) Mod 2)=0
					If (car[n*10]<car[a*10] And car[n*10]+128>car[a*10])
						car[n*10+4]=Rand(2,4)
						car[a*10+4]=Rand(1,2)
						If abang=0
							abang=30
							PlaySound(sfx[7])
						End
					End
				End
				
				If ((car[n*10+1]/32) Mod 2)=1
					If (car[n*10]<car[a*10] And car[n*10]+128>car[a*10])
						car[n*10+4]=Rand(1,2)
						car[a*10+4]=Rand(2,4)
						If abang=0
							abang=30
							PlaySound(sfx[7])
						End
						
					End					
				End
			Endif
		Next
					
		For a=1 To chks
			cary=car[n*10+1]
			carx=car[n*10]
			chkx=chk[a*10]*32+chk[n*10+4]
			chky=chk[a*10+1]*32+chk[n*10+5]
			
			If Abs(carx-chkx)<68 And Abs(cary-chky)<12
				EndofGame=1
				PlaySound(sfx[5])
			End

		Next
		
	Next

	
	If CompleteStall>0 Then CompleteStall=CompleteStall+1
	If CompleteStall>60 Then Make_Level(1)
	End
End

Function Draw_Gameplay()
	CLS3D
	ResetDraw

	For x=0 To (jscrw/256)+1
	For y=0 To (jscrh/256)+1
		DrawImg img[1],(x*256),y*256
	Next
	Next

	For x=0 To (jscrw/256)+1
		DrawImg img[4],(x*256),(gh-1)*32
	Next

	ResetDraw
	SetSize .5
	For x=0 To 3
		DrawImg img[3],(x*(jscrw/4))+(jscrw/8),16,0,1,1
		If home[x]=0
		For n=1 To chks
			If Abs(((x*(jscrw/4))+(jscrw/8))-(chk[n*10]*32+chk[n*10+4]))<32 And Abs(16-(chk[n*10+1]*32+chk[n*10+5]))<32
				home[x]=1
				chk[n*10+9]=x
				CompleteStall=1
				PlaySound(sfx[6])
			End
		Next
		End
	Next

	ResetDraw
	SetSize .5
	For n=1 To chks
		If chk[n*10+9]>0
			chk[n*10+3]=chk[n*10+3]+Rand(0,1)
			If chk[n*10+3]>63 Then chk[n*10+3]=0
			
			SetRot 180
			DrawImg img[2],(chk[n*10+9]*(jscrw/4))+(jscrw/8),16,chk[n*10+3]/4,1,1
		End
	
		If chk[n*10+9]=0
			SetRot chk[n*10+2]
			chk[n*10+3]=chk[n*10+3]+Rand(0,1)
			If chk[n*10+3]>63 Then chk[n*10+3]=0
			DrawImg img[2],chk[n*10]*32+chk[n*10+4],chk[n*10+1]*32+chk[n*10+5],chk[n*10+3]/4,1,1
			
			If chk[n*10+4]=0 And chk[n*10+5]=0 
				If MouseIn(chk[n*10]*32-48,chk[n*10+1]*32-16,32,32)
					SetRot 270
					DrawImg img[5],chk[n*10]*32-32,chk[n*10+1]*32,0,1,1
					If md=1 And (mudown=0 Or mudown=n+1)
						mudown=n+1
						PlaySound(sfx[1])
						chk[n*10+2]=270
						chk[n*10+4]=32
						chk[n*10]=chk[n*10]-1
					End
				End
				If MouseIn(chk[n*10]*32+16,chk[n*10+1]*32-16,32,32)
					SetRot 90
					DrawImg img[5],chk[n*10]*32+32,chk[n*10+1]*32,0,1,1
					If md=1 And (mudown=0 Or mudown=n+1)
						mudown=n+1
						PlaySound(sfx[2])						
						chk[n*10+2]=90
						chk[n*10+4]=-32
						chk[n*10]=chk[n*10]+1
					End
				End
				
				If MouseIn(chk[n*10]*32-16,chk[n*10+1]*32-48,32,32)
					SetRot 0
					DrawImg img[5],chk[n*10]*32,chk[n*10+1]*32-32,0,1,1
					If md=1 And (mudown=0 Or mudown=n+1)
						mudown=n+1
						PlaySound(sfx[3])						
						Score=Score+1
						chk[n*10+2]=0
						chk[n*10+5]=32
						chk[n*10+1]=chk[n*10+1]-1
					End
				End
				If MouseIn(chk[n*10]*32-16,chk[n*10+1]*32+16,32,32)
					SetRot 180
					DrawImg img[5],chk[n*10]*32,chk[n*10+1]*32+32,0,1,1
					If md=1 And (mudown=0 Or mudown=n+1)
						mudown=n+1
						PlaySound(sfx[4])						
						chk[n*10+2]=180
						chk[n*10+5]=-32
						chk[n*10+1]=chk[n*10+1]+1
					End
				End
				
			End			
			
		End
		
	Next
	
	ResetDraw
	SetSize .5
	For n=1 To cars
		If ((car[n*10+1]/32) Mod 2)=0
			DrawImg img[6],car[n*10],car[n*10+1],0,1,1
		End
		If ((car[n*10+1]/32) Mod 2)=1
			DrawImg img[7],car[n*10],car[n*10+1],0,1,1
		End

	Next
	
	ResetDraw
	UseFont 1
	If CompleteStall>0 Then Draw_LevelComplete()
	
	If EndofGame<>0 Then Draw_GameOver()
End



Function Draw_GameOver()
	ShadowText jscrw/2,jscrh/2,"Game Over",1,1
End

Function Draw_LevelComplete()
	ShadowText jscrw/2,jscrh/2,"Level Complete",1,1
End









Function Main ()
	New MainLoop
End